' ### SpamAssassin.vbs ###
' Script to start SpamAssassin from RaidenMAILD

' Version: 2.0
' Date: 15/12/2005
' By: Jeroen
' Web: http://jeroen.ishet.net
' Email: Jeroen@ishet.net

' Parameters:
'   File=Filename from the email
'   Path=Path to the email folder (This can me ignored if the path is in the filename)
'   From=Sender Email address


' modified by Theodore, 2005/12/26, arnor@raidenftpd.com, changed paths to be const variables.
' modified by Jeroen, 2005/12/29, added Global Whitelist


OPTION Explicit
On Error Resume Next


' *** Constants *** You should modify these path for your needs 

' To which folder should the spam go to?
Const strSpamFolder = "-unsolicited-\"
' To which folder should the spam be moved while checking?
Const strBusyCheck = "c:\mail\spam\BusyCheck\"
' To which folder should SpamAssassin copy the file with it's info.
Const strBusySpam = "c:\mail\spam\BusySpam\"
' Where should the logfile go?
Const strLogPath = "c:\mail\SpamAssassin.log"
' Name of the Addressbook
Const strAddressbook = "addressbook.txt"
' Name of the Whitelist
Const strWhitelist = "whitelist.txt"
' Name of the No Spam file (If this file exists in the inbox, spam will be checked, but never moved to the spam folder)
Const strNoSpamFile = "nospam.txt"
' Show the logging on screen?
Const blnShowOnScreen = True
' Check for virusses? (If you're using an on access scanner, set this to False)
Const blnVirusCheck = False
' ClamWin ClamScan path 
Const strClamWinExePath = "d:\clamwin\bin\clamscan.exe" 
' ClamWin Temporary Directory path 
Const strClamWinTempDir = "d:\clamwin\temp" 
' SpamAssassinBatPath 
Const strSpamAssassinBatPath = "c:\perl\site\bin\spamassassin.bat"
' Global Whitelist path
Const strGlobalWhiteList = "c:\mail\whitelist.txt"


' *** Declarables ***
' File System Object
Dim fso
' Arguments
Dim objArg
' Logging
Dim sLogText
' Counter
Dim iCnt

' UserPath
Dim strPath
' Email Filename
Dim strFile
' From Email
Dim strFrom
Dim posi
Dim strFrom2
' Boolean: Move the file to the spamfolder
Dim blnMoveToSpam


' *** Objects and stuff ***
' Create the File System Object
Set fso = CreateObject("Scripting.FilesystemObject")
' Get the Arguments
Set objArg = WScript.Arguments


' *** Routine For the Logfile
Sub Logging(sText)
	sLogText = sLogText & Now & " " & sText & vbCrLf
	If blnShowOnScreen Then Wscript.Echo Now & " " & sText
End Sub


' *** Routine To stop this script, write the logfile and clear all objects. ***
'   - Arguments: Reason
Sub EndScript(strReason)
' Logfile
Dim FLogFile

	' Log the reason why this script stopped
	Logging strReason

	' Open the logfile
	On Error Resume Next
	Set FLogFile = fso.OpenTextFile(strLogPath,8,1)	
	' Something went wrong while opening the logfile, most likely it's in use.
	While Err
		Err.Clear
		Set FLogFile = fso.OpenTextFile(strLogPath,8,1)
		If blnShowOnScreen Then Wscript.Echo "Logfile in use, waiting..."
		Wscript.Sleep 1000
	Wend
	On Error Goto 0
	
	' Write the data To the logfile
	FLogFile.Write sLogText
	' Close the Logfile
	FLogFile.close

	' Clean objects
	set fso = nothing
	set objArg = Nothing

	' Stop this script
	Wscript.quit(0)
End Sub


' *** Function To scan for virusses ***
'   - Arguments: Filename (incl path)
'   - Output: Errorlevel
Function VirusScan(strFilename)
Dim WshShell
Dim Result
	Logging "VirusScan"
	' Create the Shell object
	Set WshShell = CreateObject("WScript.Shell")
	'This is an example scanner from clamscan, ofcourse you can also use other scanners, or use the on access scanner.
	Result = WshShell.Run(strClamWinExePath & " -d " & chr(34) & "C:\Documents and Settings\All Users\.clamwin\db" & chr(34) & " -i --quiet -l c:\clamav.log --tempdir=" & strClamWinTempDir &" --remove " & chr(34) & strFilename & chr(34),7,True) 
	Set WshShell = Nothing
	Logging "  - Result: " & Result
	VirusScan = cint(Result)
End Function


' *** Function To start SpamAssassin ***
'   - Arguments: FromPath
'   - Arguments: ToPath
'   - Arguments: Filename (excl path)
'   - Output: Errorlevel
Function SA(strFromPath, strToPath, strFilename)
Dim WshShell
Dim Result
	Logging "SpamAssassin"
	' Create the Shell object
  Set WshShell = CreateObject("WScript.Shell")
  Result = WshShell.Run(strSpamAssassinBatPath & " -x -e < " & strFromPath & strFilename & " > " & strToPath & strFilename,7,True) 
  Set WshShell = Nothing
  Logging "  - Result: " & Result
  SA = cint(Result)
End Function


' *** Function To check If the user is in the addressbook or whitelist ***
'  - Arguments: strPath
'  - Argguments: strFrom
Function WhiteCheck(strPath, strFrom)
Dim FRead

' Addressbook
	If fso.FileExists(strPath & strAddressbook) Then
		Logging "Opening Addressbook: " & strPath & strAddressbook
		Set Fread = fso.OpenTextFile(strPath & strAddressbook, 1, False)
    While Not fread.AtEndOfStream
      If instr(lcase(fread.ReadLine),lcase(strFrom)) Then
        ' Found the E-mail address, no use To continue
			  Fread.Close
     		WhiteCheck = True
     		Exit Function
     	End If
    Wend
		Fread.Close
  Else
		Logging "Addressbook doesn't exist: " & strPath & strAddressbook
  End if


' WhiteList
	If fso.FileExists(strPath & strWhitelist) Then
		Logging "Opening WhiteList: " & strPath & strWhitelist
		Set Fread = fso.OpenTextFile(strPath & strWhitelist, 1, False)
    While Not fread.AtEndOfStream
      If instr(lcase(strFrom), lcase(fread.ReadLine)) Then
      ' Found the E-mail address, no use To continue
			  Fread.Close
     		WhiteCheck = True
     		Exit Function
     	End If
    Wend
		Fread.Close
  Else
		Logging "WhiteList doesn't exist: " & strPath & strWhitelist
  End if

' Global WhiteList
	If fso.FileExists(strGlobalWhiteList) Then
		Logging "Opening WhiteList: " & strGlobalWhiteList
		Set Fread = fso.OpenTextFile(strGlobalWhiteList, 1, False)
    While Not fread.AtEndOfStream
      If instr(LCase(strFrom), lcase(fread.ReadLine)) Then
      ' Found the E-mail address, no use To continue
			  Fread.Close
     		WhiteCheck = True
     		Exit Function
     	End If
    Wend
		Fread.Close
  Else
		Logging "WhiteList doesn't exist: " & strGlobalWhiteList
  End if


	WhiteCheck = False
End Function


' *** Read all the Arguments ***
For iCnt = 0 To objArg.count - 1
  Select Case lcase(left(objArg(iCnt),5))
  	Case "path="
  		strPath = mid(objArg(iCnt),6)
  	Case "file="
  		strFile = mid(objArg(iCnt),6)
  		If strPath = "" Then strPath = left(strFile,InStrRev(strFile,"\")) ' Delete filename, i just need the path
  		strFile = mid(strFile,InStrRev(strFile,"\")+1) ' Delete path, i just need the filename
  	Case "from="
  		strFrom = mid(objArg(iCnt),6)
		If InStr(strFrom, "|") > 0 Then
			'Logging "debug_1: " & strFrom
			strFrom2 = Mid(strFrom, 1, InStr(strFrom, "|") - 1)
			'Logging "debug_2: " & strFrom2
			If Trim(strFrom2) <> "" Then
				strFrom = strFrom2
				'Logging "debug:" & strFrom
			End If
		End if
  	Case Else
  		Logging "Unknown argument: " & objArg(iCnt)
  End Select
Next


' *** Main Routine ***

Logging "__________________________________________________"
Logging "#Start"


Logging "Checking:"
Logging "  - Path: " & strPath
Logging "  - File: " & strFile
Logging "  - From: " & strFrom

' Continue If everything is okay
' and write status To the Logfile
If strPath = "" Then EndScript("Arguments Not correct: No Path was found")
If strFile = "" Then EndScript("Arguments Not correct: No Filename was found")
If strFrom = "" Then Logging "Arguments Not correct: No from address was found (script will continue)"
If Right(strPath,1) <> "\" Then strPath = strPath & "\"


' Is the file there? or is it deleted by someone (i.e. virusscanner)?
If Not fso.FileExists(strPath & strFile) Then EndScript("File doesn't exist!")


' First move the file To a temporarilly spam folder
' Else the user would allready see this email in his inbox.
fso.movefile strPath & strFile, strBusyCheck & strFile

' Check For virusses (Optional)
If blnVirusCheck Then VirusScan(strBusyCheck & strFile)

' Is the file still there? or is it deleted by the virusscanner?
If Not fso.FileExists(strBusyCheck & strFile) Then EndScript("File doesn't exist after virusscan.")


' If the sender is in the Whitelist, Then stop scanning.
If strFrom <> "" Then
	If WhiteCheck(strPath, strFrom) Then
		' Move the file back To the inbox
		fso.movefile strBusyCheck & strFile, strPath & strFile
		EndScript("Sender is in a Whitelist")
	End If
End If

blnMoveToSpam = False ' Default: Don't move the Mail

' let Spamassassin scan the file
If SA(strBusyCheck, strBusySpam, strFile) > 0 Then blnMoveToSpam = True

' User has the NoSpamFile in his mailbox, so the file will be scanned, just Not moved.
' It will be scanned so the user can make his own rules (in Outlook) To move the spam.
If blnMoveToSpam Then
	Logging "Spam detected!"
	If fso.FileExists(strPath & strNoSpamFile) Then
		blnMoveToSpam = False
		Logging "User doesn't want To move the spam"
	End if
Else
	Logging "No spam detected"
End If


	' Yep, it's spam and it should be moved, so move it.
If blnMoveToSpam Then
	' Does the user has a spamfolder?
		If Not fso.folderexists(strPath & strSpamFolder) Then
			fso.createfolder(strPath & strSpamFolder)
			Logging "Spam folder created"
		End if

		If fso.FileExists(strBusySpam & strFile) Then
			fso.movefile strBusySpam & strFile, strPath & strSpamFolder & strFile
		Else
			Logging "Temp file (" & strBusySpam & strFile & ") not found, moving original file back, this shouldn't be happening!"
			fso.movefile strBusyCheck & strFile, strPath & strSpamFolder & strFile
		End If
Else
	' Nope, no spam or user doesn't want To move the spam, so move it back
		If fso.FileExists(strBusySpam & strFile) Then
			fso.movefile strBusySpam & strFile, strPath & strFile
		Else
			Logging "Temp file (" & strBusySpam & strFile & ") not found, moving original file back, this shouldn't be happening!"
			fso.movefile strBusyCheck & strFile, strPath & strFile
		End If
End If

	' Don't forget To delete the temp file
		fso.deletefile strBusyCheck & strFile

EndScript("#End")


' ### End Main Routine ###